Index: issm/trunk/src/c/shared/io/Marshalling/IoCodeConversions.cpp
===================================================================
--- issm/trunk/src/c/shared/io/Marshalling/IoCodeConversions.cpp	(revision 23389)
+++ issm/trunk/src/c/shared/io/Marshalling/IoCodeConversions.cpp	(revision 23394)
@@ -173,4 +173,6 @@
 		case 8: return SMBgembEnum;
 		case 9: return SMBgradientselaEnum;
+		case 10: return SMBpddSicopolisEnum;
+		case 11: return SMBgradientscomponentsEnum;
 		default: _error_("Marshalled SMB code \""<<enum_in<<"\" not supported yet");
 	}
@@ -205,5 +207,5 @@
 		case 3: return HydrologyshaktiEnum;
 		case 4: return HydrologypismEnum;
-		default: _error_("Marshalled hydrology code \""<<enum_in<<"\" not supported yet"); 
+		default: _error_("Marshalled hydrology code \""<<enum_in<<"\" not supported yet");
 	}
 }/*}}}*/
@@ -211,10 +213,10 @@
 	switch(enum_in){
 		case 1: return MatdamageiceEnum;
-		case 2: return MatestarEnum; 
+		case 2: return MatestarEnum;
 		case 3: return MaticeEnum;
 		case 4: return MatenhancediceEnum;
 		case 5: return MatlithoEnum;
 		case 6: return MaterialsEnum;
-		default: _error_("Marshalled materials code \""<<enum_in<<"\" not supported yet"); 
+		default: _error_("Marshalled materials code \""<<enum_in<<"\" not supported yet");
 	}
 }/*}}}*/
@@ -222,6 +224,6 @@
 	switch(enum_in){
 		case 1: return FixedTimesteppingEnum;
-		case 2: return AdaptiveTimesteppingEnum; 
-		default: _error_("Marshalled materials code \""<<enum_in<<"\" not supported yet"); 
+		case 2: return AdaptiveTimesteppingEnum;
+		default: _error_("Marshalled materials code \""<<enum_in<<"\" not supported yet");
 	}
 }/*}}}*/
@@ -229,6 +231,6 @@
 	switch(enum_in){
 		case 1: return AmrBamgEnum;
-		case 2: return AmrNeopzEnum; 
-		default: _error_("Marshalled AMR code \""<<enum_in<<"\" not supported yet"); 
+		case 2: return AmrNeopzEnum;
+		default: _error_("Marshalled AMR code \""<<enum_in<<"\" not supported yet");
 	}
 }/*}}}*/
Index: issm/trunk/src/c/solutionsequences/convergence.cpp
===================================================================
--- issm/trunk/src/c/solutionsequences/convergence.cpp	(revision 23389)
+++ issm/trunk/src/c/solutionsequences/convergence.cpp	(revision 23394)
@@ -7,5 +7,5 @@
 #include "../shared/shared.h"
 
-void convergence(bool* pconverged, Matrix<IssmDouble>* Kff,Vector<IssmDouble>* pf,Vector<IssmDouble>* uf,Vector<IssmDouble>* old_uf,IssmDouble eps_res,IssmDouble eps_rel,IssmDouble eps_abs){
+void convergence(bool* pconverged, Matrix<IssmDouble>* Kff,Vector<IssmDouble>* pf,Vector<IssmDouble>* uf,Vector<IssmDouble>* old_uf,IssmDouble eps_res,IssmDouble eps_rel,IssmDouble eps_abs){/*{{{*/
 
 	/*output*/
@@ -34,6 +34,9 @@
 	}
 
+
 	/*Display solver caracteristics*/
 	if (VerboseConvergence()){
+
+	
 
 		/*compute KUF = KU - F = K*U - F*/
@@ -136,3 +139,5 @@
 	/*assign output*/
 	*pconverged=converged;
-}
+}/*}}}*/
+
+
Index: issm/trunk/src/c/solutionsequences/solutionsequence_hydro_nonlinear.cpp
===================================================================
--- issm/trunk/src/c/solutionsequences/solutionsequence_hydro_nonlinear.cpp	(revision 23389)
+++ issm/trunk/src/c/solutionsequences/solutionsequence_hydro_nonlinear.cpp	(revision 23394)
@@ -190,10 +190,12 @@
 				Reduceloadx(pf,Kfs,ys); delete Kfs;
 				delete uf_epl;
+
 				femmodel->profiler->Start(SOLVER);
 				Solverx(&uf_epl,Kff,pf,uf_epl_sub_iter,df,femmodel->parameters);
 				femmodel->profiler->Stop(SOLVER);
+
 				delete Kff; delete pf; delete df;
 				delete uf_epl_sub_iter;
-				uf_epl_sub_iter=uf_epl->Duplicate();
+				uf_epl_sub_iter=uf_epl->Duplicate();_assert_(uf_epl_sub_iter);
 				uf_epl->Copy(uf_epl_sub_iter);
 				delete ug_epl;
@@ -215,6 +217,4 @@
 					_error_("   maximum number of EPL iterations (" << hydro_maxiter << ") exceeded");
 				}
-				//If there is some colapse go through sediment again
-				/* if(ThickCount<L2Count)eplconverged=true; */
 				eplcount++;
 
Index: issm/trunk/src/c/solutionsequences/solutionsequence_schurcg.cpp
===================================================================
--- issm/trunk/src/c/solutionsequences/solutionsequence_schurcg.cpp	(revision 23389)
+++ issm/trunk/src/c/solutionsequences/solutionsequence_schurcg.cpp	(revision 23394)
@@ -10,16 +10,473 @@
 #include "../analyses/analyses.h"
 
+
 #ifdef _HAVE_PETSC_
-void SchurCGSolver(Vector<IssmDouble>** puf,Mat Kff,Mat Mff,Vec pf, Vec uf0,Vec df,Parameters* parameters){/*{{{*/
+
+
+void SchurCGSolver(Vector<IssmDouble>** puf,Mat Kff,Vec pf, Vec uf0,IS isv,IS isp,Parameters* parameters){/*{{{*/
+
+	Mat                  A, B, BT;				/* Saddle point block matrices */
+	Mat						IP;						/* Preconditioner matrix */
+	Mat						IP2;
+	int                  nu, np;					/* No of. free nodes in velocity / pressure space */
+   Vec                  p,uold,unew;			/* Solution vectors for pressure / vel. */ 
+	Vec						tmpu, tmpp, rhsu,rhsp; /* temp. vectors, arbitrary RHS in vel. / pressure space */
+	Vec						gold,gnew,wold,wnew,chi,thetaold,thetanew,eta; /* CG intermediaries */
+	Vec						f1,f2;					/* RHS of the global system */
+	double					rho,gamma,tmpScalar; /* Step sizes, arbitrary double */
+	KSP						kspu,kspp;				/* KSP contexts for vel. / pressure systems*/
+	KSPConvergedReason	reason;					/* Convergence reason for troubleshooting */
+	int						its;						/* No. of iterations for troubleshooting */
+	double					initRnorm, rnorm, TOL; /* residual norms, STOP tolerance */
+	PC							pcu,pcp;					/* Preconditioner contexts pertaining the KSP contexts*/
+	PetscViewer				viewer;					/* Viewer for troubleshooting */
+	IssmPDouble				t1,t2;					/* Time measurement for bottleneck analysis */
+
+	/*STOP tolerance for the rel. residual*/
+	TOL = 0.4;
 
 	/*Initialize output*/
-	Vec uf = NULL;
-
-	_error_("not implemented yet");
+	Vector<IssmDouble>* out_uf=new Vector<IssmDouble>(uf0);
+	
+	/* Extract block matrices from the saddle point matrix */
+	/* [ A   B ] = Kff
+    * [ B^T 0 ] 
+	 *         */
+	#if (_PETSC_MAJOR_==3) && (_PETSC_MINOR_>=8)
+	MatCreateSubMatrix(Kff,isv,isv,MAT_INITIAL_MATRIX,&A);
+	MatCreateSubMatrix(Kff,isv,isp,MAT_INITIAL_MATRIX,&B);
+	MatCreateSubMatrix(Kff,isp,isv,MAT_INITIAL_MATRIX,&BT);
+	#else
+	MatGetSubMatrix(Kff,isv,isv,MAT_INITIAL_MATRIX,&A);
+	MatGetSubMatrix(Kff,isv,isp,MAT_INITIAL_MATRIX,&B);
+	MatGetSubMatrix(Kff,isp,isv,MAT_INITIAL_MATRIX,&BT);
+	#endif
+	
+	/* Extract preconditioner matrix on the pressure space*/
+	#if (_PETSC_MAJOR_==3) && (_PETSC_MINOR_>=8)
+	MatCreateSubMatrix(Kff,isp,isp,MAT_INITIAL_MATRIX,&IP);
+	#else
+	MatGetSubMatrix(Kff,isp,isp,MAT_INITIAL_MATRIX,&IP);
+	#endif
+
+	/* Get number of velocity / pressure nodes */
+	MatGetSize(B,&nu,&np);
+
+	/* Extract initial guesses for uold and pold */
+	VecCreate(IssmComm::GetComm(),&p);VecSetSizes(p,PETSC_DECIDE,np);VecSetFromOptions(p);
+	VecAssemblyBegin(p);VecAssemblyEnd(p);
+	VecCreate(IssmComm::GetComm(),&uold);VecSetSizes(uold,PETSC_DECIDE,nu);VecSetFromOptions(uold);
+	VecAssemblyBegin(uold);VecAssemblyEnd(uold);
+
+	VecGetSubVector(out_uf->pvector->vector,isv,&uold);
+	VecGetSubVector(out_uf->pvector->vector,isp,&p);
+
+
+	/* Set up intermediaries */
+	VecDuplicate(uold,&f1);VecSet(f1,0.0);
+	VecDuplicate(p,&f2);VecSet(f2,0.0);
+	VecDuplicate(uold,&tmpu);VecSet(tmpu,0.0);
+	VecDuplicate(p,&tmpp);VecSet(tmpp,0.0);
+	VecDuplicate(p,&rhsp);VecSet(rhsp,0.0);
+	VecDuplicate(uold,&rhsu);VecSet(rhsu,0.0);
+	VecDuplicate(p,&gold);VecSet(gold,0.0);
+	VecDuplicate(p,&wnew);VecSet(wnew,0.0);
+	VecDuplicate(uold,&chi);VecSet(chi,0.0);
+	VecDuplicate(p,&thetanew);VecSet(thetanew,0.0);
+	VecDuplicate(p,&thetaold);VecSet(thetaold,0.0);
+	VecDuplicate(p,&eta);VecSet(eta,0.0);
+	
+	/* Get global RHS (for each block sub-problem respectively)*/
+	VecGetSubVector(pf,isv,&f1);
+	VecGetSubVector(pf,isp,&f2);
+
+   /* ------------------------------------------------------------ */
+
+	/* Generate initial value for the velocity from the pressure */
+	/* a(u0,v) = f1(v)-b(p0,v)  i.e.  Au0 = F1-Bp0 */
+	/* u0 = u_DIR on \Gamma_DIR */
+	
+	/* Create KSP context */
+	KSPCreate(IssmComm::GetComm(),&kspu);
+	#if (_PETSC_MAJOR_==3) && (_PETSC_MINOR_>=5)
+	KSPSetOperators(kspu,A,A);
+	#else
+	KSPSetOperators(kspu,A,A,DIFFERENT_NONZERO_PATTERN);
+	#endif
+	KSPSetType(kspu,KSPCG);
+	KSPSetInitialGuessNonzero(kspu,PETSC_TRUE);
+	//KSPSetTolerances(kspu,1e-12,PETSC_DEFAULT,PETSC_DEFAULT,PETSC_DEFAULT);
+	//KSPMonitorSet(kspu,KSPMonitorDefault,NULL,NULL);
+	KSPGetPC(kspu,&pcu);
+	PCSetType(pcu,PCSOR);
+	KSPSetUp(kspu);
+
+	
+	/* Create RHS */
+	/* RHS = F1-B * pold */
+	VecScale(p,-1.);MatMultAdd(B,p,f1,rhsu);VecScale(p,-1.);
+
+	/* Go solve Au0 = F1-Bp0*/
+	KSPSolve(kspu,rhsu,uold);
+	
+
+	/* Set up u_new */
+	VecDuplicate(uold,&unew);VecCopy(uold,unew);
+	VecAssemblyBegin(unew);VecAssemblyEnd(unew);
+
+
+
+	/* ------------------------------------------------------------- */
+
+	/*Get initial residual*/
+	/*(1/mu(x) * g0, q) = b(q,u0) - (f2,q)  i.e.  IP * g0 = BT * u0 - F2*/
+	
+	/* Create KSP context */
+	KSPCreate(IssmComm::GetComm(),&kspp);
+	#if (_PETSC_MAJOR_==3) && (_PETSC_MINOR_>=5)
+	KSPSetOperators(kspp,IP,IP);
+	#else
+	KSPSetOperators(kspp,IP,IP,DIFFERENT_NONZERO_PATTERN);
+	#endif
+	
+	/* Create RHS */
+	/* RHS = BT * uold - F2 */
+	VecScale(f2,-1.);MatMultAdd(BT,uold,f2,rhsp);VecScale(f2,-1.);
+
+	/* Set KSP & PC options */
+	KSPSetType(kspp,KSPCG);
+	KSPSetInitialGuessNonzero(kspp,PETSC_TRUE);
+	KSPGetPC(kspp,&pcp);
+	PCSetType(pcp,PCJACOBI);
+	/* Note: Systems in the pressure space are cheap, so we can afford a better tolerance */
+	KSPSetTolerances(kspp,1e-10,PETSC_DEFAULT,PETSC_DEFAULT,PETSC_DEFAULT);
+	KSPSetUp(kspp);
+	
+	/* Go solve */
+	KSPSolve(kspp,rhsp,gold);
+	
+	/*Initial residual*/
+	VecNorm(gold,NORM_INFINITY,&initRnorm);
+	
+	/* Further setup */
+	VecDuplicate(gold,&gnew);VecCopy(gold,gnew);
+	VecAssemblyBegin(gnew);VecAssemblyEnd(gnew);
+
+
+	/* ------------------------------------------------------------ */
+
+	/*Set initial search direction*/
+	/*w0 = g0*/
+	VecDuplicate(gold,&wold);VecCopy(gold,wold);
+	VecAssemblyBegin(wold);VecAssemblyEnd(wold);
+
+	/*Realizing the step size part 1: thetam */
+	/*IP * theta = BT * uold - F2*/
+	VecScale(f2,-1.);MatMultAdd(BT,uold,f2,rhsp);VecScale(f2,-1.);
+	KSPSolve(kspp,rhsp,thetaold);
+
+
+	/* Count number of iterations */
+	int count = 0;
+
+	/* CG iteration*/
+	for(;;){
+
+		/*Realizing the step size part 2: chim */
+		/*a(chim,v) = -b(wm,v)  i.e.  A * chim = -B * wm */
+		/*chim_DIR = 0*/
+		VecScale(wold,-1.);MatMult(B,wold,rhsu);VecScale(wold,-1.);
+		KSPSolve(kspu,rhsu,chi);
+
+		/*Realizing the step size part 3: etam */
+		MatMult(BT,chi,rhsp);
+		KSPSolve(kspp,rhsp,eta);
+	
+		/* ---------------------------------------------------------- */
+
+
+		/*Set step size*/
+		/*rhom = [(wm)^T * IP^-1 * (BT * um - F2)]/[(wm)^T * IP^-1 * BT * chim]*/
+		VecDot(wold,thetaold,&rho);
+		VecDot(wold,eta,&tmpScalar);
+		rho = rho/tmpScalar;
+
+
+		/* ---------------------------------------------------------- */
+
+
+		/*Pressure update*/
+		/*p(m+1) = pm - rhom * wm*/
+		VecAXPY(p,-1.*rho,wold);
+
+
+		/*Velocity update*/
+		/*u(m+1) = um - rhom * chim*/
+		VecWAXPY(unew,-1.*rho,chi,uold);
+
+
+		/* ---------------------------------------------------------- */
+
+		/*Theta update*/
+		/*IP * theta = BT * uold - F2*/
+		VecScale(f2,-1.);MatMultAdd(BT,unew,f2,rhsp);VecScale(f2,-1.);
+		KSPSolve(kspp,rhsp,thetanew);
+
+
+		/* ---------------------------------------------------------- */
+
+		/*Residual update*/
+		/*g(m+1) = gm - rhom * BT * chim*/
+		VecWAXPY(gnew,-1.*rho,eta,gold);
+
+		/* ---------------------------------------------------------- */
+
+
+		/*BREAK if norm(g(m+0),2) < TOL or pressure space has been full searched*/
+		VecNorm(gnew,NORM_INFINITY,&rnorm);
+		if(rnorm < TOL*initRnorm) 
+		 break;
+		else if(rnorm > 100*initRnorm)
+		 _error_("Solver diverged. This shouldn't happen\n");
+		//else
+		// PetscPrintf(PETSC_COMM_WORLD,"rel. residual at step %d: %g, at TOL = %g\n",count,rnorm/initRnorm,TOL);
+	
+
+
+
+		if(count > np-1) break;
+	
+
+		/* ---------------------------------------------------------- */
+
+
+		/*Directional update*/
+		/*gamma = [g(m+1)^T * theta(m+1)]/[g(m)^T * thetam]*/
+		VecDot(gnew,thetanew,&gamma);
+		VecDot(gold,thetaold,&tmpScalar);
+		gamma = gamma/tmpScalar;
+
+		/*w(m+1) = g(m+1) + gamma * w(m)*/
+		VecWAXPY(wnew,gamma,wold,gnew);
+
+		/* Assign new to old iterates */
+		VecCopy(wnew,wold);VecCopy(gnew,gold);VecCopy(unew,uold);VecCopy(thetanew,thetaold);
+		
+		count++;
+	}
+
+
+	/* Restore pressure and velocity sol. vectors to its global form */
+	VecRestoreSubVector(out_uf->pvector->vector,isv,&unew);
+	VecRestoreSubVector(out_uf->pvector->vector,isp,&p);
 
 	/*return output pointer*/
-	Vector<IssmDouble>* out_uf=new Vector<IssmDouble>(uf);
-	VecFree(&uf);
 	*puf=out_uf;
+
+
+	/* Cleanup */
+	KSPDestroy(&kspu);KSPDestroy(&kspp);
+
+	MatDestroy(&A);MatDestroy(&B);MatDestroy(&BT);MatDestroy(&IP);
+	
+	VecDestroy(&p);VecDestroy(&uold);VecDestroy(&unew);VecDestroy(&rhsu);VecDestroy(&rhsp);
+	VecDestroy(&gold);VecDestroy(&gnew);VecDestroy(&wold);VecDestroy(&wnew);VecDestroy(&chi);
+	VecDestroy(&tmpp);VecDestroy(&tmpu);VecDestroy(&f1);VecDestroy(&f2);VecDestroy(&eta);
+	VecDestroy(&thetanew);VecDestroy(&thetaold);
+
+}/*}}}*/
+void convergence_schurcg(bool* pconverged, Matrix<IssmDouble>* Kff,Vector<IssmDouble>* pf,Vector<IssmDouble>* uf,Vector<IssmDouble>* old_uf,IssmDouble eps_res,IssmDouble eps_rel,IssmDouble eps_abs,IS isv,IS isp){/*{{{*/
+
+	/*output*/
+	bool converged=false;
+
+	/*intermediary*/
+	//Vector<IssmDouble>* KU=NULL;
+	//Vector<IssmDouble>* KUF=NULL;
+	//Vector<IssmDouble>* KUold=NULL;
+	//Vector<IssmDouble>* KUoldF=NULL;
+	Vector<IssmDouble>* duf=NULL;
+	IssmDouble ndu,nduinf,nu;
+	IssmDouble nKUF;
+	IssmDouble nKUoldF;
+	IssmDouble nF;
+	IssmDouble solver_residue,res;
+	int analysis_type;
+
+	Mat A, B, BT;
+	Vec u,p,uold,pold,f1,f2,tmp,res1,res2;
+	int n_u,n_p;
+	double rnorm1, rnorm2;
+
+
+	if(VerboseModule()) _printf0_("   checking convergence\n");
+
+	/*If uf is NULL in input, f-set is nil, model is fully constrained, therefore converged from 
+	 * the get go: */
+	if(uf->IsEmpty()){
+		*pconverged=true;
+		return;
+	}
+
+  /* Note: SchurCG also constructs the Schur preconditioner and stores it in the free block of Kff */
+  /*			[A    B]
+	* Kff =  |      |
+	*			[B^T IP]
+   * To calculate the residual, only the necessary blocks need to be extracted */
+
+		/*Extract A, B, B^T */
+		#if (_PETSC_MAJOR_==3) && (_PETSC_MINOR_>=8)
+		MatCreateSubMatrix(Kff->pmatrix->matrix,isv,isv,MAT_INITIAL_MATRIX,&A);
+		MatCreateSubMatrix(Kff->pmatrix->matrix,isv,isp,MAT_INITIAL_MATRIX,&B);
+		MatCreateSubMatrix(Kff->pmatrix->matrix,isp,isv,MAT_INITIAL_MATRIX,&BT);
+		#else
+		MatGetSubMatrix(Kff->pmatrix->matrix,isv,isv,MAT_INITIAL_MATRIX,&A);
+		MatGetSubMatrix(Kff->pmatrix->matrix,isv,isp,MAT_INITIAL_MATRIX,&B);
+		MatGetSubMatrix(Kff->pmatrix->matrix,isp,isv,MAT_INITIAL_MATRIX,&BT);
+		#endif
+	
+		/*no. of free nodes in velocity/pressure space*/
+		MatGetSize(B,&n_u,&n_p);
+
+		/*Extract values corresponding to the free velocity/pressure nodes*/
+		VecCreate(IssmComm::GetComm(),&p);VecSetSizes(p,PETSC_DECIDE,n_p);VecSetFromOptions(p);
+		VecAssemblyBegin(p);VecAssemblyEnd(p);
+		VecCreate(IssmComm::GetComm(),&u);VecSetSizes(u,PETSC_DECIDE,n_u);VecSetFromOptions(u);
+		VecAssemblyBegin(u);VecAssemblyEnd(u);
+
+		VecGetSubVector(uf->pvector->vector,isv,&u);
+		VecGetSubVector(uf->pvector->vector,isp,&p);
+		
+
+		/*Extract values of the RHS corresponding to the first/second block*/
+		VecDuplicate(u,&f1);VecSet(f1,1.0);
+		VecDuplicate(p,&f2);VecSet(f2,1.0);
+		VecGetSubVector(pf->pvector->vector,isv,&f1);
+		VecGetSubVector(pf->pvector->vector,isp,&f2);
+
+		/*Allocate intermediaries*/
+		VecDuplicate(u,&res1);VecSet(res1,1.0);
+		VecDuplicate(u,&tmp);VecSet(tmp,1.0);
+		VecDuplicate(p,&res2);VecSet(res2,1.0);
+
+
+	/*Display solver caracteristics*/
+	if (VerboseConvergence()){
+		
+		/*Calculate res1 = A*u + B*p - f1*/
+		VecScale(f1,-1.);MatMultAdd(A,u,f1,tmp);MatMultAdd(B,p,tmp,res1);VecScale(f1,-1.);
+		/*Calculate res2 = B^T * u - f2*/
+		VecScale(f2,-1.);MatMultAdd(BT,u,f2,res2);VecScale(f2,-1.);
+
+
+		/*compute norm(res1), norm(res2), norm(F) and residue*/
+		VecNorm(res1,NORM_2,&rnorm1);VecNorm(res2,NORM_2,&rnorm2);
+		nKUF=sqrt(rnorm1*rnorm1 + rnorm2*rnorm2);
+		nF=pf->Norm(NORM_TWO);
+		solver_residue=nKUF/nF;
+		_printf0_("\n" << "   solver residue: norm(KU-F)/norm(F)=" << solver_residue << "\n");
+		if(xIsNan<IssmDouble>(solver_residue)){
+			//Kff->Echo();
+		}
+
+	}
+	/*clean up*/
+	VecRestoreSubVector(uf->pvector->vector,isv,&u);
+	VecRestoreSubVector(uf->pvector->vector,isp,&p);
+	
+	/*Extract values corresponding to velocity/pressure on the old solution*/
+	VecGetSubVector(old_uf->pvector->vector,isv,&uold);
+	VecGetSubVector(old_uf->pvector->vector,isp,&pold);
+		
+
+	/*Force equilibrium (Mandatory)*/
+
+	/*Calculate res1 = A*uold + B*pold - f1*/
+	VecScale(f1,-1.);MatMultAdd(A,uold,f1,tmp);MatMultAdd(B,pold,tmp,res1);VecScale(f1,-1.);
+	/*Calculate res2 = B^T * uold - f2*/
+	VecScale(f2,-1.);MatMultAdd(BT,uold,f2,res2);VecScale(f2,-1.);
+	
+	/*compute norm(res1), norm(res2), norm(F) and residue*/
+	VecNorm(res1,NORM_2,&rnorm1);VecNorm(res2,NORM_2,&rnorm2);
+	nKUoldF=sqrt(rnorm1*rnorm1 + rnorm2*rnorm2);
+	nF=pf->Norm(NORM_TWO);
+	res=nKUoldF/nF;
+	if (xIsNan<IssmDouble>(res)){
+		_printf0_("norm nf = " << nF << "f and norm kuold = " << nKUoldF << "f\n");
+		_error_("mechanical equilibrium convergence criterion is NaN!");
+	}
+
+	MatDestroy(&A);MatDestroy(&B);MatDestroy(&BT);
+	VecRestoreSubVector(pf->pvector->vector,isv,&f1);
+	VecRestoreSubVector(pf->pvector->vector,isp,&f2);
+	VecDestroy(&res1);VecDestroy(&res2);VecDestroy(&tmp);
+	VecRestoreSubVector(old_uf->pvector->vector,isv,&uold);
+	VecRestoreSubVector(old_uf->pvector->vector,isp,&pold);
+	
+
+
+	//print
+	if(res<eps_res){
+		if(VerboseConvergence()) _printf0_(setw(50)<<left<<"   mechanical equilibrium convergence criterion"<<res*100<< " < "<<eps_res*100<<" %\n");
+		converged=true;
+	}
+	else{ 
+		if(VerboseConvergence()) _printf0_(setw(50)<<left<<"   mechanical equilibrium convergence criterion"<<res*100<<" > "<<eps_res*100<<" %\n");
+		converged=false;
+	}
+
+	/*Relative criterion (optional)*/
+	if (!xIsNan<IssmDouble>(eps_rel) || (VerboseConvergence())){
+
+		//compute norm(du)/norm(u)
+		duf=old_uf->Duplicate(); old_uf->Copy(duf); duf->AYPX(uf,-1.0);
+		ndu=duf->Norm(NORM_TWO); nu=old_uf->Norm(NORM_TWO);
+
+		if (xIsNan<IssmDouble>(ndu) || xIsNan<IssmDouble>(nu)) _error_("convergence criterion is NaN!");
+
+		//clean up
+		delete duf;
+
+		//print
+		if (!xIsNan<IssmDouble>(eps_rel)){
+			if((ndu/nu)<eps_rel){
+				if(VerboseConvergence()) _printf0_(setw(50) << left << "   Convergence criterion: norm(du)/norm(u)" << ndu/nu*100 << " < " << eps_rel*100 << " %\n");
+			}
+			else{ 
+				if(VerboseConvergence()) _printf0_(setw(50) << left << "   Convergence criterion: norm(du)/norm(u)" << ndu/nu*100 << " > " << eps_rel*100 << " %\n");
+				converged=false;
+			}
+		}
+		else _printf0_(setw(50) << left << "   Convergence criterion: norm(du)/norm(u)" << ndu/nu*100 << " %\n");
+
+	}
+
+	/*Absolute criterion (Optional) = max(du)*/
+	if (!xIsNan<IssmDouble>(eps_abs) || (VerboseConvergence())){
+
+		//compute max(du)
+		duf=old_uf->Duplicate(); old_uf->Copy(duf); duf->AYPX(uf,-1.0);
+		ndu=duf->Norm(NORM_TWO); nduinf=duf->Norm(NORM_INF);
+		if (xIsNan<IssmDouble>(ndu) || xIsNan<IssmDouble>(nu)) _error_("convergence criterion is NaN!");
+
+		//clean up
+		delete duf;
+
+		//print
+		if (!xIsNan<IssmDouble>(eps_abs)){
+			if ((nduinf)<eps_abs){
+				if(VerboseConvergence()) _printf0_(setw(50) << left << "   Convergence criterion: max(du)" << nduinf << " < " << eps_abs << "\n");
+			}
+			else{
+				if(VerboseConvergence()) _printf0_(setw(50) << left << "   Convergence criterion: max(du)" << nduinf << " > " << eps_abs << "\n");
+				converged=false;
+			}
+		}
+		else  _printf0_(setw(50) << left << "   Convergence criterion: max(du)" << nduinf << "\n");
+
+	}
+
+	/*assign output*/
+	*pconverged=converged;
 }/*}}}*/
 void solutionsequence_schurcg(FemModel* femmodel){/*{{{*/
@@ -32,8 +489,7 @@
 	Vector<IssmDouble>* old_uf = NULL;
 	Vector<IssmDouble>* pf  = NULL;
-	Vector<IssmDouble>* pf0 = NULL;
 	Vector<IssmDouble>* df  = NULL;
 	Vector<IssmDouble>* ys  = NULL;
-	Matrix<IssmDouble>* Mff = NULL;
+
 
 	/*parameters:*/
@@ -49,5 +505,5 @@
 	femmodel->parameters->FindParam(&configuration_type,ConfigurationTypeEnum);
 	femmodel->UpdateConstraintsx();
-
+	int size;
 	int  count=0;
 	bool converged=false;
@@ -69,34 +525,44 @@
 		/*Get stiffness matrix and Load vector*/
 		SystemMatricesx(&Kff,&Kfs,&pf,&df,NULL,femmodel);
-		pf0=pf->Duplicate(); pf->Copy(pf0);
 		CreateNodalConstraintsx(&ys,femmodel->nodes,configuration_type);
 		Reduceloadx(pf, Kfs, ys); delete Kfs;
 
 		/*Create mass matrix*/
-		int fsize; Kff->GetSize(&fsize,&fsize);
-		Mff=new Matrix<IssmDouble>(fsize,fsize,100,4);
 		StressbalanceAnalysis* analysis = new StressbalanceAnalysis();
 		/*Get complete stiffness matrix without penalties*/
 		for(int i=0;i<femmodel->elements->Size();i++){
 			Element* element=xDynamicCast<Element*>(femmodel->elements->GetObjectByOffset(i));
-			ElementMatrix* Me = analysis->CreatePressureMassMatrix(element);
-			if(Me) Me->AddToGlobal(Mff,NULL);
-			delete Me;
+			ElementMatrix* Ie = analysis->CreateSchurPrecondMatrix(element);
+			if(Ie) Ie->AddToGlobal(Kff,NULL);
+			delete Ie;
 		}
-		Mff->Assemble();
+		Kff->Assemble();
 		delete analysis;
+
+		/*Obtain index sets for velocity and pressure components */
+		IS isv = NULL;
+		IS isp = NULL;
+		#if _PETSC_MAJOR_==3
+			/*Make indices out of doftypes: */
+			if(!(df->pvector->vector))_error_("need doftypes for FS solver!\n");
+			DofTypesToIndexSet(&isv,&isp,df->pvector->vector,FSSolverEnum);
+		#else
+			_error_("Petsc 3.X required");
+		#endif
+
 
 		/*Solve*/
 		femmodel->profiler->Start(SOLVER);
 		_assert_(Kff->type==PetscMatType); 
+		
 		SchurCGSolver(&uf,
 					Kff->pmatrix->matrix,
-					Mff->pmatrix->matrix,
 					pf->pvector->vector,
 					old_uf->pvector->vector,
-					df->pvector->vector,
+					isv,
+					isp,
 					femmodel->parameters);
 		femmodel->profiler->Stop(SOLVER);
-		delete pf0; delete Mff;
+	
 
 		/*Merge solution from f set to g set*/
@@ -104,6 +570,7 @@
 
 		/*Check for convergence and update inputs accordingly*/
-		convergence(&converged,Kff,pf,uf,old_uf,eps_res,eps_rel,eps_abs); delete Kff; delete pf; delete df;
+		convergence_schurcg(&converged,Kff,pf,uf,old_uf,eps_res,eps_rel,eps_abs,isv,isp); delete Kff; delete pf; delete df;
 		count++;
+
 		if(count>=max_nonlinear_iterations){
 			_printf0_("   maximum number of nonlinear iterations (" << max_nonlinear_iterations << ") exceeded\n"); 
@@ -128,4 +595,5 @@
 
 }/*}}}*/
+
 #else
 void solutionsequence_schurcg(FemModel* femmodel){_error_("PETSc needs to be installed");}
Index: issm/trunk/src/c/toolkits/codipack/CoDiPackCommon.hpp
===================================================================
--- issm/trunk/src/c/toolkits/codipack/CoDiPackCommon.hpp	(revision 23394)
+++ issm/trunk/src/c/toolkits/codipack/CoDiPackCommon.hpp	(revision 23394)
@@ -0,0 +1,90 @@
+/*
+ * CoDiPackCommon.hpp
+ *
+ *  Created on: Mai 30, 2016
+ *      Author: sagebaum
+ */
+
+#ifndef _CODIPACK_COMMON_HPP_
+#define _CODIPACK_COMMON_HPP_
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile without HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#if defined(_HAVE_CODIPACK_)
+#include "codi.hpp"
+
+template<typename Real, typename Passive>
+inline void getVectorPrimal(const Real* vec, Passive* pasVec, int n) {
+  for(int i = 0; i < n; ++i) {
+    pasVec[i]=vec[i].getValue();
+  }
+}
+
+template<typename Real, typename Passive>
+inline void setVectorPrimal(Real* vec, const Passive* pasVec, int n) {
+  for(int i = 0; i < n; ++i) {
+    vec[i].value() = pasVec[i];
+  }
+}
+
+template<typename Real, typename Data>
+inline void getVectorGradData(const Real* vec, Data* dataVec, int n) {
+  for(int i = 0; i < n; ++i) {
+    dataVec[i]=vec[i].getGradientData();
+  }
+}
+
+template<typename Real, typename Passive, typename Data>
+inline void getVectorPrimalAndGradData(const Real* vec, Passive* pasVec, Data* dataVec, int n) {
+  for(int i = 0; i < n; ++i) {
+    pasVec[i]=vec[i].getValue();
+    dataVec[i]=vec[i].getGradientData();
+  }
+}
+
+template<typename Real, typename Passive, typename Data>
+inline void getPrimalAndGradData(const Real& value, Passive& pas, Data& data) {
+  pas=value.getValue();
+  data=value.getGradientData();
+}
+
+template<typename Real, typename Data>
+inline void registerVector(Real* vec, Data* dataVec, int n) {
+  typename Real::TapeType& tape = Real::getGlobalTape();
+
+  for(int i = 0; i < n; ++i) {
+    tape.registerInput(vec[i]);
+    dataVec[i]=vec[i].getGradientData();
+  }
+}
+
+template<typename Tape, typename Data, typename Adjoint>
+inline void getVectorAdjoint(Tape& tape, const Data* dataVec, Adjoint* adjVec, int n) {
+  for(int i = 0; i < n; ++i) {
+    Data index = dataVec[i];
+    adjVec[i] = tape.getGradient(index);
+    tape.gradient(index) = 0.0;
+  }
+}
+
+template<typename Tape, typename Data, typename Adjoint>
+inline void updateVectorAdjoint(Tape& tape, const Data* dataVec, const Adjoint* adjVec, int n) {
+  for(int i = 0; i < n; ++i) {
+    Data index = dataVec[i];
+    tape.gradient(index) += adjVec[i];
+  }
+}
+
+template<typename Tape, typename Data, typename Adjoint>
+inline void updateAdjoint(Tape& tape, const Data& data, const Adjoint& adj) {
+  Data index = data;
+  tape.gradient(index) += adj;
+}
+
+#endif
+
+#endif
Index: issm/trunk/src/c/toolkits/codipack/CoDiPackGlobal.h
===================================================================
--- issm/trunk/src/c/toolkits/codipack/CoDiPackGlobal.h	(revision 23394)
+++ issm/trunk/src/c/toolkits/codipack/CoDiPackGlobal.h	(revision 23394)
@@ -0,0 +1,40 @@
+/*
+ * CoDiPackGlobal.h
+ *
+ *  Created on: Jul 20, 2016
+ *      Author: a_h_ck
+ */
+
+#ifndef SRC_C_TOOLKITS_CODIPACK_CODIPACKGLOBAL_H_
+#define SRC_C_TOOLKITS_CODIPACK_CODIPACKGLOBAL_H_
+
+#ifdef HAVE_CONFIG_H
+    #include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#if defined(_HAVE_CODIPACK_)
+
+#include <iostream>
+#include <vector>
+
+struct CoDi_global {
+    std::vector<int> input_indices;
+    std::vector<int> output_indices;
+
+    void print(std::ostream& out) const {
+        out << "-------------------------------------\nCoDi_global:\n  in = [ ";
+        for(auto& in_index : input_indices) {
+            out << in_index << " ";
+        }
+        out << "]\n  out = [ ";
+        for(auto& out_index : output_indices) {
+            out << out_index << " ";
+        }
+        out << "]\n-------------------------------------\n";
+    }
+};
+
+#endif /* _HAVE_CODIPACK_ */
+#endif /* SRC_C_TOOLKITS_CODIPACK_CODIPACKGLOBAL_H_ */
Index: issm/trunk/src/c/toolkits/codipack/ampi_interface.cpp
===================================================================
--- issm/trunk/src/c/toolkits/codipack/ampi_interface.cpp	(revision 23394)
+++ issm/trunk/src/c/toolkits/codipack/ampi_interface.cpp	(revision 23394)
@@ -0,0 +1,14 @@
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#if defined(_HAVE_ADJOINTMPI_)
+#include "externals/ampi_interface_realreverse.cpp"
+#elif defined(_HAVE_MEDIPACK_)
+#include "medi/medi.cpp"
+#else
+#error "Cannot compile without MeDiPack and AdjointMpi"
+#endif
+
Index: issm/trunk/src/c/toolkits/codipack/codipackincludes.h
===================================================================
--- issm/trunk/src/c/toolkits/codipack/codipackincludes.h	(revision 23394)
+++ issm/trunk/src/c/toolkits/codipack/codipackincludes.h	(revision 23394)
@@ -0,0 +1,11 @@
+/* \file codipackincludes.h
+ * \brief all includes for CoDiPack layer
+ */
+
+#ifndef _COIDPACK_INCLUDES_H_
+#define _COIDPACK_INCLUDES_H_
+
+#include "./CoDiPackCommon.hpp"
+#include "./CoDiPackGlobal.h"
+
+#endif
